﻿var doc = app.activeDocument;
var radius = 300;  // ptで円の半径を設定します
var pRadius = Math.round(radius * 38.1 / 100); //五角形の半径を求める
var oneSide = 2 * pRadius * Math.sin(Math.PI / 5);  //五角形の一辺の長さを求める　Math.sin：サイン計算　Math.PI：円周率の計算
var shotSide = oneSide * 61.8 / 100; //一辺の長さを61.8％に縮小
var middleSide = pRadius * 173.181 / 100; //一辺の長さを173.181％に拡大
var longSide = pRadius * 219 /100 //中心からの距離　Y軸
var pentagonPath = [];   //空の配列を作成
var clipObj = doc.groupItems.add();  //グループアイテム

//アートボードの設定　ここから
app.coordinateSystem = CoordinateSystem.ARTBOARDCOORDINATESYSTEM;   //アートボードの座標を基準に
var rect = doc.artboards[0].artboardRect;　//アートボード座標
var left = rect[0]; //左
var top = rect[1];  //上
var right = rect[2];    //右
var bottom = rect[3];   //下
var width = right - left ;  //横幅
var height = bottom - top;  //縦幅
var center = [width / 2, height / 2];// 中心点を設定します
//アートボードの設定　ここまで


//円の作成　ここから
var circle = doc.pathItems.ellipse(center[1] +  radius, center[0] - radius , 2 * radius, 2 * radius);// 円形を作成します
circle.note = "circle"; //属性
//円の作成　ここまで

//正面五角形の作成　ここから
pentagon(center[0] , center[1], "pentagon");// 5角形の関数pentagon(中心X , 中心Y, 属性)
//正面五角形の作成　ここまで

//正面五角形のパス座標値を求める　ここから
for (var i = 0; i < doc.pathItems.length; i++){
    if(doc.pathItems[i].note === "pentagon"){   //属性が一致
        try{
            doc.pathItems[i].selected = true;   //オブジェクトの選択
        }catch(e){};
    }
}
var selObj = doc.selection; //選択中のオブジェクト
for( var i = 0; i < selObj.length; i++){//選択中のオブジェクト数だけ繰り返す
    for( var j = 0; j < selObj[i].pathPoints.length; j++){//パスポイント数だけ繰り返す
        var pathPoint = selObj[i].pathPoints[j];
        var pathAnchor = [pathPoint.anchor[0],pathPoint.anchor[1]]; //anchor:[x,y]の順番で座標値を格納
        pentagonPath.push(pathAnchor);  //座標値を配置に追加
    }
}
doc.selection = null;   //選択解除
//正面五角形のパス座標値を求める　ここまで

//周辺五角形の作成　ここから
var angles = [0, 72, 144, -144, -72];
for ( var i = 0; i < pentagonPath.length; i++){
    pentagon(pentagonPath[i][0] -sin(shotSide, angles[i]), pentagonPath[i][1] + cos(shotSide, angles[i]) - pRadius,"satelight"); // 5角形の関数pentagon(中心X , 中心Y, 属性)
};
//周辺五角形の作成　ここまで

//五角形を回転　ここから
for (var i = 0; i < doc.pathItems.length; i++){
    if(doc.pathItems[i].note === "satelight"){   //属性が一致
        try{
            doc.pathItems[i].selected = true;   //オブジェクトの選択
        }catch(e){};
    }
}
var selObj = doc.selection; //選択中のオブジェクト
var angles = [108, 36, -36, -108, 180];
for ( var i = 0; i < selObj.length; i++){
    resize(selObj[i]); //縦幅縮小
    rotate (selObj[i], angles[i]); //回転
};
doc.selection = null;
//五角形を回転　ここまで

//六角形の線を作成　ここから 
var halfWidth= selObj[2].width / 2;
var hypotenuse = Math.sqrt (Math.pow (halfWidth, 2) + Math.pow (longSide, 2))   //　斜辺を求める　Math.sqrt:平方根を求める　Math.pow：XのY乗
var angles = [[-24,-48], [-96,-120], [-168,-192], [-240,-264],[-312,-336]]
for ( var i = 0; i < angles.length; i++){
    entirePath([center[0] +  sin(hypotenuse, angles[i][0] ) ,center[1] + cos(hypotenuse, angles[i][0])],[center[0] + sin(hypotenuse, angles[i][1]) ,center[1] + cos(hypotenuse, angles[i][1])],"line");//entirePath（【スタートX,Y】、【エンドX,Y】、”属性”）
};
for( var i = 0; i < 360; i+=72){
    entirePath([center[0] +  sin(pRadius, -[i] ) ,center[1] + cos(pRadius, -[i]) ],[center[0] + sin( middleSide,-[i] ),center[1] + cos(middleSide,-[i])],"line"); //entirePath（【スタートX,Y】、【エンドX,Y】、”属性”）
};
//六角形の線を作成　ここまで

//クリッピングマスク　ここから
for (var i = 0; i < doc.pathItems.length; i++){
    if(doc.pathItems[i].note === "satelight"){   //属性が一致
        try{
            doc.pathItems[i].selected = true;   //オブジェクトの選択
        }catch(e){};

    }
}
var selObj = doc.selection; //選択中のオブジェクト
for(var i = 0; i < selObj.length; i++){
    selObj[i].move(clipObj,ElementPlacement.PLACEATBEGINNING);    //グループ化　最後尾に追加する
 }
doc.selection = null;   //選択解除
var circle = clipObj.pathItems.ellipse(center[1] +  radius, center[0] - radius , 2 * radius, 2 * radius)    //円作成
circle.stroked = false; //線なし
clipObj.clipped = true; //クリッピングマスク
//クリッピングマスク　ここまで

for (var i = 0; i < doc.pathItems.length; i++){
    if(doc.pathItems[i].note === "circle"){   //属性が一致
        try{
             doc.pathItems[i].zOrder(ZOrderMethod.SENDTOBACK); // オブジェクトを最背面に移動
        }catch(e){};
    }
}
var selObj = doc.selection;


//５角形の関数　ここから
function pentagon(xPoint , yPoint, attribute){
    var pentagon = doc.pathItems.polygon(xPoint, yPoint, pRadius, 5);// 5角形を作成します
    pentagon.fillColor = setCMYKColor (0, 0, 0, 95);
    pentagon.note = attribute;　//属性
}
//５角形の関数　ここまで

//三角関数　ここから
function cos(side,angle){
      return side * Math.cos(angle * (Math.PI / 180));   //コサインを三角関数で求める
}
function sin(side,angle){
        return side * Math.sin(angle * (Math.PI / 180));   //サインを三角関数で求める
}
function tan(side,angle){
        return side * Math.tan(angle * (Math.PI / 180));   //タンジェントを三角関数で求める
}
//三角関数　ここまで

//直線関数　ここから
function entirePath(start,end,attribute){
    var line = doc.pathItems.add();  //パスアイテム追加
    line.setEntirePath ([start,end]); //線：setEntirePath(始点[X座標、Y座標],終点[X座標、Y座標]])
    line.note = attribute; //属性
 }
//直線関数　ここまで

//オブジェクトの回転関数　ここから
function rotate(select, angle){
    select.rotate (angle, true, false, false, false, Transformation.TOP);
}
//オブジェクトの回転関数　ここまで

//リサイズ関数　ここから.
function resize(select){
    select.resize(100, 59.157, true, false, false ,false, false, Transformation.TOP);
}
//リサイズ関数　ここまで

//CMYKカラーの関数　ここから
function setCMYKColor(c,m,y,k){
    var CMYK = new CMYKColor();//CMYKの初期化
    CMYK.cyan = c;
    CMYK.magenta = m;
    CMYK.yellow = y;
    CMYK.black = k;
    return CMYK
 }
//CMYKカラーの関数　ここまで